"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.encode = encode;
exports.decode = void 0;

var R = _interopRequireWildcard(require("ramda"));

var _pow = _interopRequireDefault(require("../util/pow"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

var characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';

function encode(integer) {
  var remainder = integer;
  var result = '';

  do {
    result += characters[remainder % 62];
    remainder = Math.floor(remainder / 62);
  } while (remainder);

  return result;
}

var decode = R.compose(R.sum, R.addIndex(R.map)(function (character, index) {
  return R.multiply(characters.indexOf(character), (0, _pow["default"])(62, index));
}), R.split(''));
exports.decode = decode;